import pandas as pd
import numpy
import matplotlib.pyplot as plt
import datetime

df1 = pd.read_csv("temp.csv", delimiter=",")
df1['time']=pd.to_datetime(df1.time)
df1['time']=df1['time'].dt.strftime('%Y-%m-%d %H:%M')
df1['time']=pd.to_datetime(df1.time)
print(df1.head())


df2 = pd.read_csv("humidite.csv", delimiter=",")
df2['time']=pd.to_datetime(df2.time)
df2['time']=df2['time'].dt.strftime('%Y-%m-%d %H:%M')
df2['time']=pd.to_datetime(df2.time)
print(df2.head())

df3 = pd.read_csv("CO2.csv", delimiter= ",")
df3['time']=pd.to_datetime(df3.time)
df3['time']=df3['time'].dt.strftime('%Y-%m-%d %H:%M')
df3['time']=pd.to_datetime(df3.time)
print(df3.head())

def set_second(df):
  for i in range(len(df)):
    df['time'][i] = df['time'][i].replace(second=0)
  return df

def float_dataframe(df):
  n = len(df)
  for i in range(n):
    df.iloc[:,1][i] = float(df.iloc[:,1][i])
  return df


def discretize_minute(df):  # parcourt la liste et si deux date ont plus qu'une minute d'écart on discrétise

    Time = [df.iloc[0, 0]]
    Value = [df.iloc[0, 1]]

    n = len(df)
    i = 0
    while i != n - 1: #tant qu'on n'a pas parcouru tout le tableau
        duration = df['time'][i + 1] - df['time'][i] #on va calculer le nombre de minutes entre deux éléments successifs
        duration_in_s = duration.total_seconds()
        a = int(duration_in_s / 60)
        if a > 1:
            b = a - 1 #le nombre d'interpolation a créé
            c = (df.iloc[:, 1][i + 1] - df.iloc[:, 1][i]) / (b + 1) #calcul du pas d'interpolation
            for j in range(1, b + 1): #pour chaque interpolation à réaliser
                Time.append(df.iloc[:, 0][i]) #on ajoute un nouvel élément
                #Time[-1] = Time[-1].replace(minute=df['time'][i].minute + j)
                Time[-1] = Time[-1] + datetime.timedelta(seconds = j*60)
                Value.append(df.iloc[:, 1][i] + c * j)
            Time.append(df.iloc[:, 0][i + 1])
            Value.append(df.iloc[:, 1][i + 1])

        else:
            Time.append(df.iloc[:, 0][i + 1])
            Value.append(df.iloc[:, 1][i + 1])

        i += 1

    d = {df.columns[0]: Time, df.columns[1]: Value}
    df1 = pd.DataFrame(data=d)

    return df1


def mean_dataframe(df):
    Time = []
    Value = []
    n = len(df)
    time_init = df.iloc[0, 0]

    time_fin = df.iloc[-1, 0]

    i = 0
    j = 0
    date = time_init
    while date <= time_fin:
        if i == 60 * 24:
            j += 1
            date = time_init + dt.timedelta(days=j)
            i = 0
        else:
            date = time_init + dt.timedelta(minutes=i)

        df_date = df[df['time'] == date]
        df_value = df_date.iloc[:, 1]

        mean_df = np.mean(list(df_value))
        Value.append(mean_df)
        Time.append(date)
        i += 1

    d = {df.columns[0]: Time, df.columns[1]: Value}
    df1 = pd.DataFrame(data=d)

    return df1

df1 = discretize_minute(df1)
print(df1.head())

df2 = discretize_minute(df2)
print(df2.head())

df3 = discretize_minute(df3)
print(df3.head())

df0 = pd.merge(df1, df2, on=['time'], suffixes=('_temperature', '_humidite'))
print(df3)
df = pd.merge(df0, df3, on=['time'])
df = df.rename(columns={"value": "value_co2"})
print(df)


def ventilation(x, y, z):
    temp = x.copy()
    humidite = y.copy()
    CO2 = z.copy()
    ventilation = []
    for i in range(len(x)):
        ventilation.append(0)
        if temp[i] > 26:
            ventilation[i] = "clim"
            temp[i] = 26
        elif temp[i] < 17:
            ventilation[i] = "chauffage"
            temp[i] = 17
        elif humidite[i] < 40:
            ventilation[i] = "humidificateur"
            humidite[i] = 40
        elif humidite[i] > 70:
            humidite[i] = 70
            ventilation[i] = "dehumidificateur"
        elif humidite[i] > 60 and temp[i] > 22:
            humidite[i] = 60
            ventilation[i] = "dehumidificateur"

    for i in range(len(CO2)):
        if CO2[i]>1100:
            CO2[i] = 1100

    return temp, humidite, CO2

temp, humidite, CO2 = ventilation(df0['value_temperature'], df0['value_humidite'], df3['value'])


plt.plot(df0['time'], df0['value_humidite'])
plt.plot(df0['time'], humidite)
plt.show()

plt.plot(df0['time'], df0['value_temperature'])
plt.plot(df0['time'], temp)
plt.show()

plt.plot(df3['time'], df3['value'])
plt.plot(df3['time'], CO2)
plt.show()

plt.scatter(temp, humidite)
plt.show()